"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchRequest,
    avro_parse,
    load_schema,
)


class SearchReferencesRequest(SearchRequest):
    """
    This request maps to the body of `POST /references/search` as JSON.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.methods.SearchReferencesRequest": ga4gh_3_1_1.SearchReferencesRequest,
        }

    __slots__ = [
        "accessions",
        "md5checksums",
        "pageSize",
        "pageToken",
        "referenceSetId",
    ]

    def __init__(
        self,
        accessions=list,
        md5checksums=list,
        pageSize=None,
        pageToken=None,
        referenceSetId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.SearchReferencesRequest model.

        :param accessions:
            If nonempty, return references for which the accession   matches this
            string. Best to give a version number e.g.
            `GCF_000001405.26`.   If only the main accession number is
            given then all records with   that main accession will be
            returned, whichever version.   Note that different
            versions will have different sequences.
        :type accessions: list[str]
        :param md5checksums:
            If nonempty, return references which match any of the given
            `md5checksums`.   See `Reference::md5checksum` for
            details.
        :type md5checksums: list[str]
        :param pageSize:
            Specifies the maximum number of results to return in a single page.
            If unspecified, a system default will be used.
        :type pageSize: None | int
        :param pageToken:
            The continuation token, which is used to page through large result
            sets.   To get the next page of results, set this
            parameter to the value of   `nextPageToken` from the
            previous response.
        :type pageToken: None | str
        :param referenceSetId:
            If not null, return only references which belong to this reference
            set.
        :type referenceSetId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
